/*
  This program is free software published under the
  terms of the GNU Lesser General Public License.
  http://www.gnu.org/copyleft/lesser.html    
  This program is distributed in the hope that it will
  be useful - WITHOUT ANY WARRANTY; without even the
  implied warranty of MERCHANTABILITY or FITNESS FOR A
  PARTICULAR PURPOSE.
*/ 


/*  xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
     source code: ES6 (ECMAScript 6, ECMAScript 2015, JavaScript 6)
    xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx */

 
//                          wm17 version: 1.0


//  xxxxxxxxxxxxxxx    global variable declarations  xxxxxxxxxxxxxxxx


// These variables below can be directly modified by the user on the options form: 


// These variables below can be directly modified by the user on the options form: 

var item_cnt= 5;     // total number of items in the task

var c_cnt = 6;   		 // number of choices (options) in each item during the task 

var tcolor = '1';    // Color palette type: '1' => Full Random colors, '2' => Only basic html colors; '3' => Grey colors
	
var wait = 30;   // number of basic time cycles BEFORE first part of main stimulus exposition. Units = number of basic timer resolution (clock=100ms). Time of displaying the fixing cross. Time between stimuli. 

var time = 10;     // stimulus exposition time in ms. Units = number of basic timer resolution (clock=100ms)

var delay = 10;   // delay between stimulus and user response. Units = number of basic timer resolution (clock=100ms)

var is_cross = true;       // if is_cross=true =>  The cross will appear in the center of the screen before the main stimulus 
    
var demo = true;     // if (demo == true) => Show the correct choice 

var is_back = true;    // if (is_back==true) => user can undo last answer (go back to previous task/item).  

var is_req = false;  // if (is_req==true) => The user must enter valid numeric values before moving to a new item.

var prg_type = true;   //  type of information in Progress Bar (true => Items, false => Nothing) 

var store = false;      // false => this web application will not store results within client web browser.; true => This web application will store the results inside client web browser. 


// Other global constants and variables:

const clock = 100;  // basic timer resolution in ms

const c_max= 10; // maximum number of choices in task

var step = -1;   		 	 // global timer counter => see appTimer()

var timer_id = null;   // timer_id is the identifier of the repeated action you want to cancel. This ID is returned from setInterval().

var is_task = false;    // task in progress or not for pageResize() event. is_task == true for all events between startTask() and theEnd() events

var dirty = false;  		// if  (dirty==true) => user changed any options in form 

var item = 0;   				// current item in task     

var is_storage= false;  // local storage is enabled on user browser or not

 
//  global arrays declarations.. 

// 16 x shades of gray => Grey color codes chart + White color codes chart
const grey = ['#DCDCDC', '#D3D3D3', '#C0C0C0', '#A9A9A9', '#808080', '#696969', '#778899', '#708090', '#000000', '#F8F8FF', '#F5F5F5', '#FFF5EE', '#FFFAF0', '#FFFFF0', '#FAF0E6', '#FFDEAD' ];
  
var stim = [];   // [item] x [c_cnt] x [index 0 = hex color; index 1 = opacity ]

var cor = [];    // [item] => corrrect choice (option) count started from 1. possible range: 1 .. c_cnt

var ans = [];    // [item] => selected choice (option) count started from 1. possible range: 1 .. c_cnt


/*  xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
    xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
		xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx */


// application init [create/start Timer, check storage, show start panel..] 
function init() 
{  
  if (timer_id)  {   
    window.clearInterval(timer_id);  
  }     
	timer_id= setInterval(function () {appTimer()},clock); 
	is_storage= isStorage() && storageAvailable('localStorage');
  if (is_storage)  {
    document.getElementById('store_group').style.display= 'block';
		document.getElementById('no_storage').style.display= 'none';
  }			  
	setIns();		
	showStart();
}


// before using web storage, check browser support for localStorage and sessionStorage
function isStorage()  
{
  if (typeof(Storage) !== 'undefined') {
     return true;                 
  } 
  else {
    return false;    
  }  
}


// necessarily because of IE11 
function storageAvailable(type) 
{
  try  {
    return (window[type]) ? true: false;   
  }
  catch(e) {
    return false;
  }
}


// application timer handler function
// basic timer resolution is aprox 100 ms
function appTimer()    
{  
  
	 if (step < 0) {          //   if (step < 0 || !is_task) {
		 return;  // nop, idle, just wait
   }
	 step++; 
   
   let c0= document.getElementById('0'), ctx= c0.getContext('2d');         
   if (step < wait-1)  
	 {  // time before stimulus (time between stimuli)            	
      if (step == 1)  
			{				 
				document.getElementById('prior').style.display= (item > 0 && is_back) ? 'inline': 'none';  // set footer navigation prior button (left arrow) 		
				document.getElementById('next').style.display= 'none';  // disable next item while complete stimulus in not done 
				if (is_cross) 
				{
					c0.style.display= 'inline';
					ctx.globalAlpha= 1;
					ctx.clearRect(0, 0, c0.width, c0.height);  // must be								 
					 //c0.style.backgroundColor= '#fff';
					 //c0.style.opacity = 1; 										
					drawCross();   // always trigger this in first timer call	
				}
			}
			else if (is_cross && step > wait - 20)
			{  // flick cross only in two second before main stimulus (change cross state visible <=> not visible)
				if (step % 2 != 0)  {    
					drawCross();     // draw Cross only if it is odd number  (1,3,5,..)  example if (wait==6) = 3xflick 					
				}
				else    {       // for even numbers  (2,4,6,..) => clear previous cross. 
					ctx.clearRect(0, 0, c0.width, c0.height);     // clear canvas => clear Cross in 2,4,6 step					
				}  
			}      
   }
   else if (step == wait-1)   
	 {       // ALWAYS clear canvas before main stimulus display
     if (is_cross) { 		   		   
		   ctx.clearRect(0, 0, c0.width, c0.height);      // clear last cross if exists 		
		 }	 
   }    
   else if (step == wait) {
     drawStim(true);     // draw first part of stimulus (match)  		 
   }
   else if (step == wait+time) 
	 {
     ctx.clearRect(0, 0, c0.width, c0.height);      // clear first part of stimulus  (stimulus before delay)             
	 }
   else if (step >= wait+time+delay) 
	 {    
		 drawStim(false);     // after delay draw second part of stimulus (stimulus after delay)         
		 step = -1;          // nop, idle, do none, Timer no operation     
   }
} 


// draws a cross before the main stimulus
function drawCross()  
{
  let c= document.getElementById('0');   
  let x= Math.round(c.width/2);
  let y= Math.round(c.height/2);
  let d = Math.floor(Math.min(x,y)/4);  // 1/8 min(width, height)  
  drawLine(x-d,y,x+d,y); // horizontal
  drawLine(x,y-d,x,y+d); // vertical 
}


// draw line on screen canvas
function drawLine(x1,y1,x2,y2)  
{  
	let ctx= document.getElementById('0').getContext('2d'); 
  ctx.beginPath();
  ctx.moveTo(x1,y1);
  ctx.lineTo(x2,y2);  
  ctx.lineWidth= 3;  
	ctx.strokeStyle= '#000';  
  ctx.stroke(); 
}


/* evaluates the user's response with the mouse
   event => HTML DOM MouseEvent Object 
   e => html canvas object  */
function doAns(e)  
{		
	let n= e.id; // id started from index 0  
	if (n == 0) { 
		return; // first part of stimulus (stimulus before delay period)
	}  
	if ( ans[item][n] == 0 ) 
	{    // user answer => toogle all choices
		for (let j in ans[item])  
		{
   		if ( j == n ) {
				ans[item][n]= 1;  
	    }
			else  {
				ans[item][j]= 0;
			}
		}
	}
  else   {
    ans[item][n]= 0;   		
	}	
  drawStim(false);  // repaint second part of stimulus (stimulus after delay )
}


// get currently selected choices count for current window.item
function getSelCnt()
{
	let res= 0;
	for (let j in ans[item])  {
		if ( ans[item][j] == 1 )  {
			res++;
		}
	}
	return res;
}	


// stop timer and draw second part previous stimulus again (this is now previous item)
function undoAnswer()  {     
  step = -1;         // stop timer (nop, idle, do none, Timer no operation)                  
  if (item > 0) { 
		item--;
  }	
  document.getElementById('prior').style.display= 'none';  // enable go back only for last item        
  drawStim(false);     // draw again second part of previous stimulus
}


// goto next item (stimulus)
function nextItem()  
{ 
	if (is_req && getSelCnt() < 1) {
		alert('You must select one color in each task.');
		return;
	}
	
	document.getElementById('next').style.display= 'none';
	for (let i= 1; i <= c_max; i++)  {	  // when task start all stimulus are invisible
	  document.getElementById(i).style.display= 'none';
	}		
		
	item++;		

	if (item < item_cnt)  {         		 
     step= 0;     // "activate" Timer again        
  }
  else  {               
    step= -1 ; 
		theEnd();  // end of task if item >= item_cnt. Note: only this line code call theEnd()  
  }
}


// raised when page is resized. see html: <body onresize="pageResize()"..
function pageResize()  
{ 
	if (is_task)  
	{ 		
		// FIRST update footer when show each stimulus in task. update buttons and update progress bar 
		updateFooter();
		
		// w => total width for all canvas objects  
		// h => total height for all canvas objects 		
		let w = Math.min(window.innerWidth, document.body.clientWidth);  
		let h = Math.min(window.innerHeight, document.body.clientHeight) - document.getElementById('footer').offsetHeight - 20; // document.getElementById('footer').clientHeight == document.getElementById('footer').offsetHeight;  
	
    switch (c_cnt) 
		{
			case 2:
			case 3:
				setCanvas(c_cnt, c_cnt, w, h);  // all in one row
				break;
			 	
			case 4:
			case 8: 
				setCanvas(c_cnt/2, c_cnt, w, h);  // 2 rows
				break;
				
			case 5:
			case 10:
				setCanvas(5, c_cnt, w, h);  // 1 or 2 rows
				break;

			case 6:
			case 9:
				setCanvas(3, c_cnt, w, h);  // 2 or 3 rows
				break;	
				
	    default :		// case 7 only	=> 2 rows 			 
				setCanvas(Math.ceil(c_cnt/2), c_cnt, w, h);					
        //break;
		}
		// repaint first or second part of main stimulus if they are visible on screen				
    if ( step >= wait && step < wait+time ) {
		  drawStim(true);     // repaint (draw again) first part of stimulus (before delay) 	
		}			
		else if ( document.getElementById('1').style.display == 'inline' )  {   
			drawStim(false);  // repaint second part of stimulus (after delay) 	
		}
	}
}	


// https://css-tricks.com/absolute-relative-fixed-positioining-how-do-they-differ/
/* set all canvas objects positions (layout)
   n => maximum number of element in each row. last row can have < elements.
   tot => total numbers of elements (objects)
   w => total width for all canvas objects  
   h => total height for all canvas objects */ 	
function setCanvas(n, tot, w, h)  
{	 	
	let rows= Math.ceil(tot/n);  // number of rows on screen
	let rem = tot % n; // number of objects in last row
	const x1= Math.floor(w/n);   // width
	const	y1= Math.floor(h/rows);  // height
	let x0= 0;  // left
	let y0= 0;  // top
	let i= 1, j= 1, off; 
	while ( i <= tot )  
	{				  			    
		let c= document.getElementById(i); // canvas.id started from 0    
		c.style.left= x0 + 'px';
		c.style.top= y0 + 'px';
		c.style.width= x1 + 'px';
		c.width= x1;  // https://css-tricks.com/whats-the-difference-between-width-height-in-css-and-width-height-html-attributes/ 			  
		c.style.height= y1 + 'px';				
		c.height= y1;		
		i++; // total canvas counter
		j++; // counter within each row				
		let is_dif= (rem > 0 && i > tot - rem) ? true : false;  // is it last row different from all others				
		if ( j > n )  
		{  // start new row	
			j= 1;
			y0+= y1;  // add height for new row			   			 	
			if ( is_dif )  {  // last row is different from others 
				off= Math.floor( (w - rem * x1) / (rem+1) ); // left offset (x). update left position (for center horizonally)
				x0= off; 				
			}
			else  {
				x0= 0;
			}				
		}
		else  { // this is not new row
			x0+= is_dif ? x1 + off : x1;
		}
	}
	
	// center stimulus before delay on screen center
	let c0= document.getElementById('0');
	let c1= document.getElementById('1');
	
	c0.style.width= c1.style.width;
	c0.width= c1.width;  // https://css-tricks.com/whats-the-difference-between-width-height-in-css-and-width-height-html-attributes/ 			  
	
	c0.style.height= c1.style.height;				
	c0.height= c1.height;			
	
	c0.style.left= parseInt((w - c0.width) / 2, 10) + 'px';
	c0.style.top= parseInt((h - c0.height) / 2, 10) + 'px';
}


// update footer (back button and progress bar)
function updateFooter()  
{
	document.getElementById('prior').style.display= item > 0 && is_back ? 'inline': 'none';  // set footer navigation
	let btn= document.getElementById('next');     
	if (item == item_cnt-1)  {       
		btn.style.backgroundImage=  "url('img/end.png')";  // update 'Next item' image on 'right arrow' button 
		btn.title= 'End of task';
	}
	else  {
		btn.style.backgroundImage= "url('img/forward.png')"; 
		btn.title= 'Go forward';
	}						
	if (prg_type)  {    // update Progress bar => show current item count and remaining item count on Progress Bar (default)                                                                                                                                                       
		let percent = Math.round(100*(item_cnt-(item+1))/item_cnt);      
		document.getElementById('progress').setAttribute('style', 'width:'+percent+'%');    // !important
		//document.getElementById('nav_items').textContent= 'Item= ' + (item + 1) + ' Remaining= ' + (item_cnt - item-1);  
	}			
}


/* https://developer.mozilla.org/en-US/docs/Web/API/Canvas_API/Tutorial/Applying_styles_and_colors
   draw current (main) stimulus 
   if (first == true)  => display first part of stimulus (stimulus before delay); 
   if (first == false) => display second part of stimulus (stimulus after delay);  */        
function drawStim(first) 
{		 
  updateFooter();
	if (first)
	{ 
	  document.getElementById('prior').style.display= 'none';
		for (let i= 1; i <= c_cnt; i++)  {	  // when task start all stimulus are invisible
			document.getElementById(i).style.display= 'none';
		}		
		let c0= document.getElementById(0), ctx= c0.getContext('2d');	
		c0.style.display= 'inline';	
		ctx.globalAlpha= stim[item][0][1];	// xxx index 1 => opacity
		ctx.fillStyle = stim[item][0][0];   // xxx index 0 => backgroundColor xxx  		
		ctx.fillRect(0, 0, c0.width, c0.height);
			//c0.style.opacity= stim[item][0][1];			    // cross browser didn't work ok => index 1 => opacity	
			//c0.style.backgroundColor= stim[item][0][0]; // cross browser didn't work ok => index 0 => backgroundColor xxx 
	}
	else  
	{
		document.getElementById(0).style.display= 'none';
		for (let j=1; j <= c_cnt; j++)  
		{	
			let c= document.getElementById(j), ctx= c.getContext('2d');
			c.style.display= 'inline'; 
			ctx.clearRect(0, 0, c.width, c.height);  // must be			
			ctx.globalAlpha= stim[item][j][1]; 		// xxx index 1 => opacity
			ctx.fillStyle = stim[item][j][0];     // xxx index 0 => backgroundColor xxx 
			ctx.fillRect(0, 0, c.width, c.height);
				//c.style.opacity=  stim[item][j][1]; 		 	 // cross browser didn't work ok =>  index 1 => opacity	
				//c.style.backgroundColor= stim[item][j][0]; // cross browser didn't work ok =>  index 0 => backgroundColor xxx     		 
			ctx.lineWidth= 3; 
			if ( ans[item][j] == 1 )  
			{					
				ctx.strokeStyle= '#fff';
			  ctx.beginPath();
				ctx.moveTo(0, 0);
				ctx.lineTo(c.width, c.height);
				ctx.stroke(); 
			  
				ctx.strokeStyle= '#000';
			  ctx.beginPath();
				ctx.moveTo(0, c.height);
				ctx.lineTo(c.width, 0);
				ctx.stroke();  				
			}
			document.getElementById('next').style.display= 'inline';			
		}				
	}		
}


// show start panel 
function showStart()  
{      
  document.getElementById('end').style.display= 'none';
  document.getElementById('result_wrapper').style.display= 'none';  
  document.getElementById('store_id').style.display= 'none';
	document.getElementById('table_grp').style.display= 'none';
	document.getElementById('start').style.display= 'block';	
}


// show form with application options
// <!-- IMPORTANT: showOption() and hideOption() buttons must be outside form element -->
function showOption()   
{ 
  document.getElementById('hide_option').style.display= 'block';
  document.getElementById('options').style.display= 'block';
  document.getElementById('start').classList.remove('center-xy');  // ex 'child' class    
  document.getElementById('start_div').style.display= 'none';    
  document.getElementById('show_option').style.display= 'none';  
  document.getElementById('hide_option').style= 'text-align:center';  // bug? auto-remove style when element.style.display="none"
  document.getElementById('instructions').style.display= 'none';     
  document.getElementById('store_oper').style.display= 'none';
	if (is_storage && localStorage.getItem('wm17-v1.0')) 
  {
    let cnt= JSON.parse(localStorage.getItem('wm17-v1.0')).length;                                                        
    document.getElementById('store_cnt').textContent=  'You have a total of ' + cnt  + ' WM17 results stored in your web browser.';
    if (cnt > 0) {
			document.getElementById('store_oper').style.display= 'table';  // Watch this line: this was a nasty bug 
		}
	}
  dirty= false;
  //document.getElementById('is_valid').textContent='';  // tmp reset validator message	
}


// <!-- IMPORTANT: showOption() and hideOption() buttons must be outside form element -->
// save to window global vars all user Options/Settings
function hideOption()  
{
  setVarPar();   
  document.getElementById('options').style.display = 'none'; 
  document.getElementById('start').classList.add('center-xy');   // ex 'child' class 
  document.getElementById('show_option').style.display = 'block';   
  document.getElementById('start_div').style.display = 'block';          
  document.getElementById('hide_option').style.display = 'none';   
  //document.getElementById('start_div').style= 'text-align:center';  // bug?  (firefox auto remove class "center" when set style.display.none;)
  document.getElementById('show_option').style= 'text-align:center';  
  document.getElementById('instructions').style.display= 'block'; 
	refMsg(); 
  setIns();	
}


// set instructions text depending on user selected task options
function setIns()  
{
  document.getElementById('instructions').style.display= 'block';		
  
	document.getElementById('ins_cross').style.display = is_cross ? 'block' : 'none';	
	
	document.getElementById('ins_req').style.display = is_req ? 'block' : 'none';	

  document.getElementById('ins_back').style.display = is_back ? 'block' : 'none';	
		
	document.getElementById('ins_demo').style.display= demo ? 'block' : 'none';
}	


// refresh Options (update *_msg label) => give user short option HELP
function refOpt(e)  
{   
  dirty=true;       
  let my_id = e.id, msg = document.getElementById(my_id + '_msg'), s = 'Values within this range are allowed: ', s2= ' with step= ';               
	switch (my_id)
	{
			
    case 'item_cnt':
		case 'c_cnt':
    case 'wait':		
		case 'time':
		case 'delay':
			if (e.validity.valid)  {           
				msg.removeAttribute('class');       
				msg.textContent= '';       //msg.textContent=  e.value; 
			}
			else  {
				msg.textContent= s + e.min + '..' + e.max + s2 + e.step;
				msg.setAttribute('class', 'error');    // msg.className = 'error';
			}   
      break;

    case 'tcolor':
		  if (e.value == '1')  {
				msg.textContent= 'All possible HTML colors will be used in the task.'
			}
			else if (e.value == '2')  {
				msg.textContent= 'A set of 16 (mostly) basic HTML colors will be used.'; 
			}
			else   {                 
				msg.textContent= 'Only shades of gray and white will be used in the task (16 similar colors).';
			}
		  break;
			
		// case is_cross:	
			
		case 'demo': 
		  msg.textContent= e.checked ? 'Yes. The correct solution in each task will be the default marked with an "X".' : 'No';
		  break;
		
		case 'is_back':
		  msg.textContent= e.checked ? 'Yes. It is possible to return to the previous task before displaying the next stimulus.' : 'No. After moving on to the next task, it is not possible to return to the previous task.';
		  break;
			
		case 'is_req':
		  msg.textContent= e.checked ? 'Yes. Color selection is required in each item.' : 'No. It is not necessary to select a color within each item.';
		  break;
			
		case 'prg_type':
       msg.textContent= e.checked ? 'Yes' : 'No'; 
       break; 
 		
		case 'store':                                                                                                                                            
			msg.textContent= (e.value === '1') ? 'This web application will store the results inside your web browser (no expiration date). Useful for group research' : 'This web application will not store results within your web browser. Data is lost when the browser tab is closed';
			break;
 
	}   // switch
		
  refMsg();   
}


// refresh main validator message for user defined OPTIONS 
function refMsg()   
{ 	
	if ( optionsValid() )  {
    document.getElementById('is_valid').textContent=  dirty === true ? 'All your settings have been successfully updated' : '';  
    document.getElementById('is_valid').setAttribute('style', 'text-align:center;color:#000000'); 
  }
  else  {
    document.getElementById('is_valid').textContent='Some of your options are incorrectly set. They were not updated.';   // These settings are marked in red. 
    document.getElementById('is_valid').setAttribute('style', 'text-align:center;color:#ff0000;font-weight:bold'); 
  } 	
}


// check for validity.valid object in all input type="number"
function optionsValid()  
{ 
  let res= document.getElementById('item_cnt').validity.valid && document.getElementById('c_cnt').validity.valid
				&& document.getElementById('wait').validity.valid  && document.getElementById('time').validity.valid 
				&& document.getElementById('delay').validity.valid;
  return res;              
}


// start task (research) 
function startTask(e)   
{   

  initLayout();     			
  
	setPar();
			
	stimGen();
	
	pageResize();
						
	step=0;   // finally "activate" timer 
	
}


// init visible/invisible html dom elements, progress bar and background colors
function initLayout()
{
  document.getElementById('start').style.display= 'none';              
	document.getElementById('task_section').style.display= 'block'; 	  
  //document.getElementById('result_wrapper').style.display= 'none'; => showStart()
  //document.getElementById('end').style.display= 'none';  => showStart()
	//document.getElementById('canvas_section').style.display= 'inline'; 			   		
	//document.getElementById('footer').style.display= 'block'; 		
	document.getElementById('nav_items').textContent='';  // reset  
	
	if ( prg_type == false )  {
		document.getElementById('progress_holder').style.display= 'none';  
	}	
	else  {
		document.getElementById('progress_holder').style.display= 'block'; 
		document.getElementById('progress').setAttribute('style', 'width:100%');    				   			
		document.getElementById('progress').setAttribute('style', 'width:100%');  // reset progress bar width						 	
	}
 	
	document.getElementById(0).style.borderStyle= 'none';
	for (let i= 1; i <= c_max; i++)  {	  // when task start all stimulus are invisible
	  document.getElementById(i).style.display= 'none';
	}		

}


// set internal application parameters (window global vars)
function setPar()  
{ 
  
	item= 0;	
	stim = [];
	cor = [];   
	ans = [];  
  
  for (let i= 0; i < item_cnt; i++)  
	{		  
		ans[i]= [];    // user selected choices
		// stim and cor arrays are set in stimGen() 
		for (let j= 0; j <= c_cnt; j++)  {
			ans[i][j]= 0;   // for each item => all choices are set to unselected == 0		
		}
	}
	is_task= true; 
}


// stimulus generator. set: window.stim, window.cor arrays
function stimGen()	
{	
  const delta= 1/c_cnt;  // decrease opacity value in each choice by this value
	let prior=-1, rnd, clr;
  for (let i= 0; i < item_cnt; i++)  
	{
		stim[i]= []; 	
		let opa = 1;  //  opacity = 1 (default value) =>	The element is fully opaque (visually solid). opacity = 0 =>	The element is fully transparent (that is, invisible).			
		let s= {};
		let sol= getRndInt(1, c_cnt);  // sol => correct choice within this item i
		cor.push(sol);   // global var => save correct choice for this i-item
		if (demo) {
			ans[i][sol]= 1;
		}			
		do
		{ 
			switch (tcolor)
			{
				case '1':
					clr = getRndColor();
					break;
				case '2':
					clr = get16Color();
					break;
				case '3':			
					clr = grey[Math.floor(Math.random() * 16)];     // index returns a random integer from 0 to 15 
					break;
			} 
		} while ( clr == prior );
		stim[i][0] = [clr, null];  // stimulus before delay
		for (let j = 1; j <= c_cnt; j++) 
		{  // repeat for each visible canvas object (choice) in current item			 			
			do {
				rnd= getRndInt(1, c_cnt);  // canvas.id range: 1 .. number of choices in each item
			} while (typeof s[rnd] != 'undefined');
			s[rnd]= 1;
			stim[i][rnd] = [clr, opa];  // index 0 => backgroundColor; 1 => opacity
			if ( rnd == sol ) {
				stim[i][0][1] = stim[i][rnd][1];  // copy opacity
			}			
			opa-= delta;	
		}
		prior= clr;   // previous selected color
	}
}


// get random integer from min to max range
function getRndInt(min, max) {
	return Math.floor(Math.random() * (max - min + 1)) + min;
}


// get full random colors in hex format
function getRndColor() {
  let letters = '0123456789abcdef';
  let color = '#';
  for (let i = 0; i < 6; i++) {
    color += letters[Math.floor(Math.random() * 16)];     // returns a random integer from 0 to 15 
  }
  return color;
}  


// sets one of mostly basic html predefined colors
// this is mostly default set of 16 html Basic colors 
function get16Color() 
{
  let clr = [    
    '#000000',     /* "black" */   
    '#FF0000',     /* "red"   */
    '#008000',     /* "green" */
    '#0000FF',     /* "blue" */   
    '#FFFF00',     /* "yellow" */     
    '#00FF00',     /* "lime" */     
    '#00FFFF',     /* "cyan" / "aqua" */     
    '#FF00FF',     /* magenta / fuchsia  */  
    '#C0C0C0',     /* "silver" */      
    '#800000',     /* maroon */     
    '#808000',     /* "olive" */  
    '#800080',     /* "purple" */    
    '#008080',     /* teal */      
    '#000080',     /* navy */    
    '#FFC0CB',     /* "pink" */           
    '#FFA500'      /* "orange" */ 
    ];      
  let rnd= Math.floor(Math.random()*16);   // returns a random integer from 0 to 15 
  //let rnd= getRndInt(0,15);  // array clr limits
	return clr[rnd];
}


// Changes application settings that can be changed directly by the user within the options form
function setVarPar()  
{   
	if (document.getElementById('item_cnt').validity.valid) {
	  item_cnt= parseInt(document.getElementById('item_cnt').value, 10); 
	} 	
	
  if (document.getElementById('c_cnt').validity.valid) {
		c_cnt= parseInt(document.getElementById('c_cnt').value, 10); 
	} 	
	
  tcolor= document.getElementById('tcolor').value;
	
  if (document.getElementById('wait').validity.valid) {
		wait= Math.round(parseInt(document.getElementById('wait').value, 10)/clock);
  }
  
	if (document.getElementById('time').validity.valid) {
		time= Math.round(parseInt(document.getElementById('time').value, 10)/clock);  
  }
	
  if (document.getElementById('delay').validity.valid) {
		delay= Math.round(parseInt(document.getElementById('delay').value, 10)/clock); 
	}	

  is_cross= document.getElementById('is_cross').value == '1' ? true: false;   
			
  demo= document.getElementById('demo').checked ? true: false;	
	
	is_back= document.getElementById('is_back').checked ? true: false;        
  
  is_req= document.getElementById('is_req').checked ? true: false; 
	
	prg_type= document.getElementById('prg_type').value == '1' ? true : false;  // display item count on footer or nothing
	
  store= (document.getElementById('store_group').disabled === false && document.getElementById('store').value === '1') ? true : false;

}


// end of task (research)
// https://www.socscistatistics.com/tests/spearman/default2.aspx
function theEnd()  
{  
  is_task= false;   
	
	document.getElementById('task_section').style.display= 'none';	
	//document.getElementById('canvas_section').style.display= 'none';
	//document.getElementById('footer').style.display= 'none';  	
  document.getElementById('end').style.display= 'block';   
  document.getElementById('result_wrapper').style.display= 'block'; 

	// show (calculate) Frequencies => table1	
	let header= ['Item', 'Selected', 'Correct', 'Point'], rows= []; 
	let points= 0, mis= 0;  // points => sum of points in whole task, mis= missing values ih whole task
	for (let i= 0; i < item_cnt; i++)  
	{
		let len= ans[i].length, p= 0, s= ''; // p = number of point is this item (0 or 1). s = selected choice in this item 		
		for (let j= 1; j < len; j++)    // for each (visible) choice in this item
		{ 
			if ( ans[i][j] == 1 )    
			{  
		    s= j;    // selected choice
        if ( j == cor[i] )  {
					p= 1;  // selected choice is correct choice within this item
				}										
			}
		}
		if ( s == '' ) {
			mis++;
		}	
		rows.push( [ parseInt(i+1,10), s, cor[i], p ] ); 
		points+= p;
	}
	rows.push( [ 'Sum', '', '', points ] ); 
	createTableArray(document.getElementById('table1'), rows, header);	
	
	// "chart" => repaint "chart" 
  let ok= Math.round(100 * points / item_cnt).toFixed(2);
	let not_ok= Math.round(100 - ok).toFixed(2); 
	document.getElementById('chart_1').setAttribute('style', 'width:' + ok + '%');    // !important
	document.getElementById('chart_2').setAttribute('style', 'width:' + not_ok + '%');	
	document.getElementById('chart').title= 'The percentage of points scored (green) = ' + ok + '% (100* ' + points + '/' + item_cnt + ')';  	
	// update 'score' label => above "Repeat" button
	document.getElementById('score').textContent= 'Total number of points = ' + points + '. Maximum possible number of points = ' + item_cnt + '. Missing items= ' + mis;  

	document.getElementById('l_ts').textContent='Last completed research: ' + new Date();
  document.getElementById('l_res').style.display= 'block';
		
	try 
  {
    if (store) {
			setStorage(points, mis);  
    }
  }        
  catch (e)  { 
    document.getElementById('table_grp').style.display= 'block';
		document.getElementById('table_grp').textContent= "Your browser probably doesn't have support for the Web Storage Object or access to the Storage Object is disabled. Check your browser settings. In some browsers (IE11, Edge) Storage Object is not enabled when accessed in a local file (offline)."; 
  }   	 

}


// Formats the date in the desired format. If you do not want this string format do not call this function. use: new Date()
function setDate()  
{
	let today = new Date();
	let dd = today.getDate();
	let mm = today.getMonth()+1; 
	let yyyy = today.getFullYear();
	if(dd<10) { dd='0'+dd; } 
	if(mm<10) {	mm='0'+mm; } 
	today = dd+'.' + mm + '.' +yyyy;
	return today;
}


/* Store the results of the last completed task in the user's browser
   set user data into window.localStorage. Parameters:	 
	 points = total number of points in task. each item => 0 or 1 point
   missing = 	missing values in task (no selected choice) */
function setStorage(points, missing)   
{   
	let oldItems = JSON.parse(localStorage.getItem('wm17-v1.0')) || []; 
  let id= oldItems.length+1;     	
	// set new "record"
  let newItem = {
      'id' : id,
      'date' : setDate(),   //new Date(),  		   
      'points' : points,
			'missing' : missing,	
			'items': item_cnt,			
			'demo' : demo ? 1 : 0,			
			'choices': c_cnt,
			'palette': tcolor,			
	    'time-between' : wait * clock,        
      'time-display' : time * clock,
      'time-delay' : delay * clock,			
			'cross' : is_cross ? 1 : 0,			
			'backward': is_back ? 1 : 0,
			'required' : is_req ? 1 : 0						
  };

  oldItems.push(newItem);

  localStorage.setItem('wm17-v1.0', JSON.stringify(oldItems));
  
	document.getElementById('table_grp').style.display= 'block';
  document.getElementById('store_id').style.display= 'block';
  document.getElementById('store_id').textContent= 'The results are stored in your browser. ID= ' + id ;
  
	createTableJSON(document.getElementById('table_grp'), oldItems);   

}


// convert JSON data dynamically to HTML Table using JavaScript - Dynamically Create table with rows in JavaScript
// downloaded and adapted from source: https://www.encodedna.com/javascript/populate-json-data-to-html-table-using-javascript.htm
function createTableJSON(elem, my_json) 
{  
  // EXTRACT VALUE FOR HTML HEADER. 
  let col = [];
  for (let i = 0; i < my_json.length; i++) {
    for (let key in my_json[i]) {
        if (col.indexOf(key) === -1) {
            col.push(key);
        }
    }
  } 
  let table = document.createElement("table");
  // CREATE HTML TABLE HEADER ROW USING THE EXTRACTED HEADERS ABOVE.
  let tr = table.insertRow(-1);                   // TABLE ROW.
  for (let i = 0; i < col.length; i++) {
      let th = document.createElement("th");      // TABLE HEADER.
      th.innerHTML = col[i];
      tr.appendChild(th);
  }
  // ADD JSON DATA TO THE TABLE AS ROWS.
  for (let i = 0; i < my_json.length; i++) 
  {
    tr = table.insertRow(-1);
    for (let j = 0; j < col.length; j++) {
      let tabCell = tr.insertCell(-1);
      tabCell.innerHTML = my_json[i][col[j]];
    }
  }
  // FINALLY ADD THE NEWLY CREATED TABLE WITH JSON DATA TO A CONTAINER.
  elem.innerHTML= "";
  elem.appendChild(table);
}


/* convert array data dynamically to HTML table - dynamically create html table
   elem == DOM html container (element)
   data => 1-dim or 2-dim array (matrix)
   col => string column descriptions. Set an empty string if you want to skip a column inside a 2-dim array	 */ 
function createTableArray(elem, data, col) 
{  
	let table= document.createElement('table');  // html table
  let tr= table.insertRow(-1), th, cell, tmp;  // table row, table header, table cell 	
  // create html table header row using the extracted headers above  
  for (let i in col) {
		if ( col[i] == '' ) { continue; } // set an empty string if you want to skip a column inside a 2-dim array
		th= document.createElement('th');      
		th.innerHTML = col[i];
		tr.appendChild(th);
  }
  if ( is2dArray(data) ) 
	{ // add 2-dim array data to the table as rows		
		tmp= data.length;
		for (let i = 0; i < tmp; i++) 
		{
			tr= table.insertRow(-1);
			for (let j in col) {
				if (col[j] == '') { continue; }  // set an empty string if you want to skip a column inside a 2-dim array
				cell= tr.insertCell(-1);
				cell.innerHTML = data[i][j];
			}
		}
  }
	else 
	{	// add 1-dim array data to the table as only one row
		tr= table.insertRow(-1);
		tmp=data.length;
		for (let i = 0; i < tmp; i++)	{
			cell= tr.insertCell(-1);
			cell.innerHTML = data[i];
		}
	}	
  elem.innerHTML= '';
  elem.appendChild(table);  // finally add the newly created table with string data to a html container
}


// test if array is 2-dim (return true) or not (return false)
function is2dArray(arr)
{
	if(arr[0] === undefined){
		return false;
	}
	else	{
		return (arr[0].constructor === Array);
	}
}


// begin of new code for export localStorage app data:  data= localStorage.getItem('myApp-v1.0');

// clear web browser storage data for this application
function clrStorage()  
{  
  let cnt= localStorage.getItem('wm17-v1.0')  ?  JSON.parse(localStorage.getItem('wm17-v1.0')).length : 0;                                                        
  if (cnt === 0)  {
    alert('You have no WM17 data to delete');
    return;
  }  
  if ( !window.confirm('You have a total of ' + cnt  + ' WM17 results stored in your web browser. Continue?') ) { 
   return;
 }                                             
 if (window.confirm('Delete total saved WM17 results:  '  + cnt + '. This action cannot be undone. Final confirmation?') ) 
 {  
   window.localStorage.removeItem('wm17-v1.0'); 
   document.getElementById('store_cnt').textContent= 'All data has been deleted. No data.';
	 document.getElementById('store_oper').style.display= 'none';
 }  
}


// copy data from user web browser to the Clipboard 
function copyStorage()  
{  
  let data= localStorage.getItem('wm17-v1.0');
	if (!data)  {
    alert('You have no data to Copy');
    return;
  }  
	data = JSON.parse(data); 
	let arr= jsonToArray(data);	
	copy2DToClipboard(arr);
}	


// convert json object into 2D array
// data = JSON object
// return 2D array
function jsonToArray(data)  
{
   // extract column (fields) names  
  let total= data.length, col = [], row, res=[];  // res= result (2d array) 
  for (let i = 0; i < total; i++) {
    for (let key in data[i]) {
			if (col.indexOf(key) === -1)  {
				col.push(key);  // col= columns (fields) names
			}
    }
  } 
	res.push(col);  // add field names as 1 row
  let c = col.length;    // column count  
  // add JSON data to the 2d array as rows.
  for (let i = 0; i < total; i++) 
  {
		row= [];
    for (let j = 0; j < c; j++)  {     
      row.push(data[i][col[j]]);
    }
		res.push(row);
  }
	return res;	
}


// https://stackoverflow.com/questions/60698115/how-to-copy-a-javascript-2d-array-to-clipboard-to-paste-it-in-excel
// copy 2D array to Clipboard
function copy2DToClipboard(arr) {
  let csv = '', row, cell;
  for (row = 0; row < arr.length; row++) {
    for (cell = 0; cell < arr[row].length; cell++) {
      csv += (arr[row][cell]+'').replace(/[\n\t]+/g, ' ');
      if (cell+1 < arr[row].length) csv += '\t';
    }
    if (row+1 < arr.length) { 
			csv += '\n'; 
		}
  }
  copyTextToClipboard(csv);
}


// copy 2D array (or text) to Clipboard
function copyTextToClipboard(txt) 
{	
	if (!navigator.clipboard) {
    fallbackCopy(txt);
    return;
  }
  navigator.clipboard.writeText(txt).then(function() {
   //alert('Async: Copying to Clipboard was successful!');
  }, function(err) {
    alert('Oops, could not copy data. Error: ' + err);
  });
}


// copied from https://stackoverflow.com/questions/400212/how-do-i-copy-to-the-clipboard-in-javascript
// fallback copy text to clipboard
function fallbackCopy(txt) 
{
  let ta = document.createElement('textarea');
  ta.value = txt; 
  // Avoid scrolling to bottom
  ta.style.top = '0';
  ta.style.left = '0';
  ta.style.position = 'fixed';
  document.body.appendChild(ta);
  ta.focus();
  ta.select();
  try {
    let successful = document.execCommand('copy');
    let msg = successful ? 'successful' : 'unsuccessful';
  } catch (err) {
    alert('Oops, unable to copy. Error: ' + err);
  }
  document.body.removeChild(ta);
}


// https://stackoverflow.com/questions/2004555/how-can-i-make-javascript-make-produce-new-page
// displays user saved results (Window.localStorage application data) in new empty web page (tab) 
function newWin()
{ 
	let data = JSON.parse(localStorage.getItem('wm17-v1.0'))
	createTableJSON(document.getElementById('table_grp'), data);
	let stl= '<style>table{margin:1em auto;border:thick solid #000;border-collapse:collapse}td,th{border:medium solid #000;text-align:center;padding:.5em}th{font-weight:bold}</style>';
	let tbl= document.getElementById('table_grp').innerHTML;	
	let win = window.open('');
  win.document.write('<html><head><title>Saved cumulative data</title>' + stl + '</head><body>' + tbl + '</body></html>');
  win.focus();
}


// https://stackoverflow.com/questions/2004555/how-can-i-make-javascript-make-produce-new-page
// displays Latest research results in new empty web page (tab) 
// parameter: id => DOM/html object (div or table)
function newWinLast(id)
{ 
  let e = document.getElementById(id);	
	let stl= '<style>table{margin:1em auto;border:thick solid #000;border-collapse:collapse}td,th{border:medium solid #000;text-align:center;padding:.5em}th{font-weight:bold}</style>';
	let tbl= e.innerHTML; 	
	let win = window.open('');
	win.document.write('<html><head><title>Latest research data</title>' + stl + '</head><body>' + tbl + '</body></html>');
	win.focus();
}


// copy only latest task results (data) to the Clipboard 
function copyLast()  
{     
  let tbl = document.getElementById('table1').getElementsByTagName('table')[0];  // note: id='table1' is html div element
  if (tbl)  {
		let data= table2DArray(tbl);
		if (data.length > 0) {
			copy2DToClipboard(data);
		}
	}
}	


// https://stackoverflow.com/questions/3065342/how-do-i-iterate-through-table-rows-and-cells-in-javascript
// input argument tbl == html/DOM  table  object
// return 2D array
function table2DArray(tbl) 
{
	let res = [];	 
	for (let i = 0, row; row = tbl.rows[i]; i++) 
	{   //iterate through rows. rows would be accessed using the "row" variable assigned in the for loop
	  res[i]= [];		
		for (let j = 0, col; col = row.cells[j]; j++) {  //iterate through columns. columns would be accessed using the "col" variable assigned in the for loop			 
		  res[i][j]= col.textContent;
		}  
	}
	return res;				
}
